## mingw-w64-qucs-s-25.2.0-1.src.tar.zst

=== library/CMakeLists.txt ===

SET(COMPLIBS
555_timer.lib
Analog.lib
AudioIC.lib
Bridges.lib
BJT_Extended.lib
Cores.lib
Crystal.lib
Diodes.lib
DiodesSchottky.lib
Diodes_Extended.lib
Digital_AUX.lib
Digital_CD.lib
Digital_HC.lib
Digital_LV.lib
Digital_XSPICE.lib
DualGateMOSFET.lib
FerritesEpcos.lib
FerritesFerroxcube.lib
FerritesAmidon.lib
GeDiodes.lib
Ideal.lib
JFETs.lib
LEDs.lib
LaserDiodes.lib
Loudspeaker.lib
MixerIC.lib
Neon.lib
MOSFETs.lib
NMOSFETs.lib
OpAmps.lib
Optocoupler.lib
PhotovoltaicRelay.lib
PMOSFETs.lib
PWM_Controller.lib
Regulators.lib
RC.lib
Substrates.lib
Transistors.lib
Varistors.lib
Z-Diodes.lib
SpiceOpamp.lib
SPICE_TLine.lib
Thermistor.lib
Thyristor.lib
Transformers.lib
TubesExtended.lib
Xanalogue.lib
XyceDigital.lib
Xyce_Digital_TTL_Technology.lib
BF998.lib
Tubes.lib
Varactor.lib
Varactor_RF.lib
PIN_Diodes.lib
VoltageComparators.lib
VoltageReferences.lib
VoltageRegulators.lib
VDMOS.lib
VDMOS_IR.lib
)

SET(BLACKLIST
qucs.blacklist
ngspice.blacklist
xyce.blacklist
)

INSTALL( FILES ${COMPLIBS} ${BLACKLIST} DESTINATION share/${QUCS_NAME}/library )
INSTALL( DIRECTORY "symbols" DESTINATION share/${QUCS_NAME}/ )
INSTALL( DIRECTORY "TubesExtended" DESTINATION share/${QUCS_NAME}/library)
INSTALL( DIRECTORY "Optocoupler" DESTINATION share/${QUCS_NAME}/library )
INSTALL( DIRECTORY "DualGateMOSFET" DESTINATION share/${QUCS_NAME}/library )
INSTALL( DIRECTORY "spicelibrary" DESTINATION share/${QUCS_NAME}/ )

ADD_SUBDIRECTORY( XyceDigital)

=== qucs-attenuator/CMakeLists.txt ===
PROJECT(qucsattenuator CXX C)
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)
cmake_policy(VERSION 3.10)

SET(QUCS_NAME "qucs-s")

# use top VERSION file
file (STRINGS ${PROJECT_SOURCE_DIR}/../VERSION QUCS_VERSION)

if(DEFINED CI_VERSION)
    set(PROJECT_VERSION "${CI_VERSION}")
else()
    set(PROJECT_VERSION "${QUCS_VERSION}")
endif()

message(STATUS "Configuring ${PROJECT_NAME} (GUI): VERSION ${PROJECT_VERSION}")

set(PROJECT_VENDOR "Qucs team. This program is licensed under the GNU GPL")
set(PROJECT_COPYRIGHT_YEAR "2014")
set(PROJECT_DOMAIN_FIRST "qucs")
set(PROJECT_DOMAIN_SECOND "org")


add_compile_definitions(HAVE_CONFIG_H)
SET(CMAKE_POSITION_INDEPENDENT_CODE ON)

# configure the header config.h
CONFIGURE_FILE (
    "${PROJECT_SOURCE_DIR}/../config.h.cmake"
    "${PROJECT_BINARY_DIR}/config.h"
)

INCLUDE_DIRECTORIES("${PROJECT_BINARY_DIR}")

find_package(Qt6 REQUIRED COMPONENTS Core Gui Widgets)
include_directories(
      ${Qt6Core_INCLUDE_DIRS}
      ${Qt6Gui_INCLUDE_DIRS}
      ${Qt6Widgets_INCLUDE_DIRS}
      )

set(QT_VERSION ${Qt6Core_VERSION})

if (${QT_VERSION} VERSION_LESS "6.7.0")
    set(CMAKE_CXX_STANDARD 17)
else()
    set(CMAKE_CXX_STANDARD 20)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
        add_compile_definitions(_CRT_SECURE_NO_WARNINGS _SCL_SECURE_NO_WARNINGS)
        add_compile_options(/permissive- /Zc:__cplusplus /Zc:preprocessor /MP /Od /vmg)
        add_compile_options(/wd4244 /wd4267 /wd4312)
    else()
        add_compile_options(-Wall -Wextra -O0 -g)
        if (CMAKE_CXX_COMPILER_ID MATCHES "^AppleClang$|^Clang$")
            add_compile_options(-Wno-ignored-attributes)
        endif()
    endif()
elseif(CMAKE_BUILD_TYPE STREQUAL "Release")
    if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
        add_compile_definitions(_CRT_SECURE_NO_WARNINGS _SCL_SECURE_NO_WARNINGS)
        string(REGEX REPLACE "/W1" "/w" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
        add_compile_options(/permissive- /Zc:__cplusplus /Zc:preprocessor /MP /vmg)
        add_link_options(/OPT:REF /OPT:ICF)
    else()
        add_compile_options(-w)
    endif()
endif()

ADD_DEFINITIONS(${QT_DEFINITIONS})

#ADD_SUBDIRECTORY( bitmaps ) -> added as resources

SET( attenuator_sources attenuatorfunc.cpp main.cpp qucsattenuator.cpp )

SET( attenuator_moc_headers qucsattenuator.h )

SET(RESOURCES qucsattenuator.qrc)

QT6_WRAP_CPP( attenuator_moc_sources ${attenuator_moc_headers} )
QT6_ADD_RESOURCES(RESOURCES_SRCS ${RESOURCES})

IF(APPLE)
  # set information on Info.plist file
	SET(MACOSX_BUNDLE_INFO_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
  SET(MACOSX_BUNDLE_BUNDLE_VERSION "${PROJECT_NAME} ${PROJECT_VERSION}")
  SET(MACOSX_BUNDLE_LONG_VERSION_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
  SET(MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}")
  SET(MACOSX_BUNDLE_COPYRIGHT "${PROJECT_COPYRIGHT_YEAR} ${PROJECT_VENDOR}")
  SET(MACOSX_BUNDLE_GUI_IDENTIFIER "${PROJECT_DOMAIN_SECOND}.${PROJECT_DOMAIN_FIRST}")
  SET(MACOSX_BUNDLE_BUNDLE_NAME "${PROJECT_NAME}")
  SET(MACOSX_BUNDLE_ICON_FILE qucsattenuator.icns)

  # set where in the bundle to put the icns file
  SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_SOURCE_DIR}/../qucs/bitmaps/qucsattenuator.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  # include the icns file in the target
  SET(attenuator_sources ${attenuator_sources} ${CMAKE_CURRENT_SOURCE_DIR}/../qucs/bitmaps/qucsattenuator.icns)

ENDIF(APPLE)

ADD_EXECUTABLE( ${QUCS_NAME}attenuator MACOSX_BUNDLE WIN32
  ${attenuator_sources}
  ${attenuator_moc_sources}
  ${RESOURCES_SRCS} )

TARGET_LINK_LIBRARIES( ${QUCS_NAME}attenuator Qt6::Core Qt6::Gui Qt6::Widgets )
SET_TARGET_PROPERTIES(${QUCS_NAME}attenuator PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
#INSTALL (TARGETS ${QUCS_NAME}attenuator DESTINATION bin)
#
# Prepare the installation
#
SET(plugin_dest_dir bin)
SET(qtconf_dest_dir bin)
SET(APPS "${CMAKE_INSTALL_PREFIX}/bin/${QUCS_NAME}attenuator")
IF(APPLE)
  SET(plugin_dest_dir ${QUCS_NAME}attenuator.app/Contents/MacOS)
  SET(qtconf_dest_dir ${QUCS_NAME}attenuator.app/Contents/Resources)
  SET(APPS "${CMAKE_INSTALL_PREFIX}/bin/${QUCS_NAME}attenuator.app")
ENDIF(APPLE)

IF(WIN32)
  SET(APPS "${CMAKE_INSTALL_PREFIX}/bin/${QUCS_NAME}attenuator.exe")
ENDIF(WIN32)

#
# Install the Qucs application, on Apple, the bundle is
# installed as on other platforms it'll go into the bin directory.
#
INSTALL(TARGETS ${QUCS_NAME}attenuator
    BUNDLE DESTINATION bin COMPONENT Runtime
    RUNTIME DESTINATION bin COMPONENT Runtime
    )


#
# Install needed Qt plugins by copying directories from the qt installation
# One can cull what gets copied by using 'REGEX "..." EXCLUDE'
#
IF(APPLE AND QT_PLUGINS_DIR)
  INSTALL(DIRECTORY "${QT_PLUGINS_DIR}/imageformats" DESTINATION bin/${plugin_dest_dir}/plugins COMPONENT Runtime)
ENDIF()
#
# install a qt.conf file
# this inserts some cmake code into the install script to write the file
#
IF(APPLE)
INSTALL(CODE "
    file(WRITE \"\${CMAKE_INSTALL_PREFIX}/bin/${qtconf_dest_dir}/qt.conf\" \"\")
    " COMPONENT Runtime)
ENDIF()

#--------------------------------------------------------------------------------
# Use BundleUtilities to get all other dependencies for the application to work.
# It takes a bundle or executable along with possible plugins and inspects it
# for dependencies.  If they are not system dependencies, they are copied.

# directories to look for dependencies
IF(APPLE)
  SET(DIRS ${QT_LIBRARY_DIRS})
ENDIF()

# Now the work of copying dependencies into the bundle/package
# The quotes are escaped and variables to use at install time have their $ escaped
# An alternative is the do a configure_file() on a script and use install(SCRIPT  ...).
# Note that the image plugins depend on QtSvg and QtXml, and it got those copied
# over.
IF(APPLE)
INSTALL(CODE "
    file(GLOB_RECURSE QTPLUGINS
      \"\${CMAKE_INSTALL_PREFIX}/bin/${plugin_dest_dir}/plugins/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
    include(BundleUtilities)
    fixup_bundle(\"${APPS}\" \"\${QTPLUGINS}\" \"${DIRS}\")
    " COMPONENT Runtime)
ENDIF()

=== qucs/CMakeLists.txt ===
# To have CMake pick a Qt installation of your choice that won't be found
# automatically, set the CMAKE_PREFIX_PATH environment variable.
# For example: "export CMAKE_PREFIX_PATH=/usr/local/trolltech/qt4.3.5"
#
# You can change the install location by
# running cmake like this:
#   mkdir build; cd build
#   cmake .. -DCMAKE_INSTALL_PREFIX=/new/install/prefix
#
# By default, the prefix is "/usr/local"

PROJECT(qucs-s CXX)
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)
cmake_policy(VERSION 3.10)

SET(QUCS_NAME "${PROJECT_NAME}")

# use top VERSION file
file (STRINGS ${PROJECT_SOURCE_DIR}/../VERSION QUCS_VERSION)

if(DEFINED CI_VERSION)
    set(PROJECT_VERSION "${CI_VERSION}")
else()
    set(PROJECT_VERSION "${QUCS_VERSION}")
endif()

message(STATUS "Configuring ${PROJECT_NAME} (GUI): VERSION ${PROJECT_VERSION}")

set(PROJECT_VENDOR "Qucs team. This program is licensed under the GNU GPL")
set(PROJECT_COPYRIGHT_YEAR "2014")
set(PROJECT_DOMAIN_FIRST "qucs")
set(PROJECT_DOMAIN_SECOND "org")

# If Git hash not defined, try to define it
#IF(NOT GIT)
#  IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../../.git )
#    FIND_PACKAGE(Git)
#    # Get the latest abbreviated commit hash of the working branch
#    execute_process(
#      COMMAND ${GIT_EXECUTABLE} log --pretty=format:%h -n 1u
#      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
#      OUTPUT_VARIABLE GIT_COMMIT_HASH
#    )
#    set(GIT ${GIT_COMMIT_HASH})
#    message(STATUS "Found Git repository, last commit hash: ${GIT}")
#  ENDIF()
#ENDIF()

if(UNIX AND NOT APPLE)
  #string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWERCASE)
  #set(BIN_INSTALL_DIR "bin")
  #set(DOC_INSTALL_DIR "share/doc/${PROJECT_NAME_LOWERCASE}/")
else()
  #set(BIN_INSTALL_DIR ".")
  #set(DOC_INSTALL_DIR ".")
endif()

#
add_compile_definitions(HAVE_CONFIG_H)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

find_package(Qt6 REQUIRED COMPONENTS Core Gui Widgets Svg SvgWidgets Xml PrintSupport)
include_directories(
      ${Qt6Core_INCLUDE_DIRS}
      ${Qt6Widgets_INCLUDE_DIRS}
      ${Qt6Svg_INCLUDE_DIRS}
      ${Qt6SvgWidgets_INCLUDE_DIRS}
      ${Qt6Xml_INCLUDE_DIRS}
      ${Qt6PrintSupport_INCLUDE_DIRS}
      )


#MESSAGE("QT_INCLUDES=[${QT_INCLUDES}]")
#MESSAGE("QT_LIBRARIES=[${QT_LIBRARIES}]")
# configure the header config.h
CONFIGURE_FILE (
    "${PROJECT_SOURCE_DIR}/../config.h.cmake"
    "${PROJECT_BINARY_DIR}/config.h"
)

INCLUDE_DIRECTORIES("${PROJECT_BINARY_DIR}")

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(QT_VERSION ${Qt6Core_VERSION})

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
        add_compile_definitions(_CRT_SECURE_NO_WARNINGS _SCL_SECURE_NO_WARNINGS)
        add_compile_options(/permissive- /Zc:__cplusplus /Zc:preprocessor /MP /Od /vmg)
        add_compile_options(/wd4244 /wd4267 /wd4312)
    else()
        add_compile_options(-Wall -Wextra -O0 -g)
        if (CMAKE_CXX_COMPILER_ID MATCHES "^AppleClang$|^Clang$")
            add_compile_options(-Wno-ignored-attributes)
        endif()
    endif()
elseif(CMAKE_BUILD_TYPE STREQUAL "Release")
    if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
        add_compile_definitions(_CRT_SECURE_NO_WARNINGS _SCL_SECURE_NO_WARNINGS)
        string(REGEX REPLACE "/W1" "/w" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
        add_compile_options(/permissive- /Zc:__cplusplus /Zc:preprocessor /MP /vmg)
        add_link_options(/OPT:REF /OPT:ICF)
    else()
        add_compile_options(-w)
    endif()
endif()

INCLUDE_DIRECTORIES(
  ${PROJECT_SOURCE_DIR}
  #${qucs_SOURCE_DIR}/bitmaps ->no sources here
  ${PROJECT_SOURCE_DIR}/components
  ${PROJECT_SOURCE_DIR}/diagrams
  ${PROJECT_SOURCE_DIR}/dialogs
  ${PROJECT_SOURCE_DIR}/geometry
  #${qucs_SOURCE_DIR}/octave ->no sources here
  ${PROJECT_SOURCE_DIR}/paintings
  ${PROJECT_SOURCE_DIR}/third_party
  )

#ADD_SUBDIRECTORY( bitmaps ) -> added as resources
ADD_SUBDIRECTORY( qt3_compat )
ADD_SUBDIRECTORY( components )
ADD_SUBDIRECTORY( magnetics )
ADD_SUBDIRECTORY( diagrams )
ADD_SUBDIRECTORY( dialogs )
ADD_SUBDIRECTORY( geometry )
ADD_SUBDIRECTORY( octave )
ADD_SUBDIRECTORY( python )
ADD_SUBDIRECTORY( paintings )
ADD_SUBDIRECTORY( extsimkernels )
ADD_SUBDIRECTORY( spicecomponents )

SET(QUCS_SRCS
  element.cpp	octave_window.cpp	qucsdoc.cpp
  textdoc.cpp  main.cpp	schematic.cpp
  mnemo.cpp	qucs.cpp healer.cpp
  module.cpp	schematic_element.cpp	wire.cpp schematic_render.cpp
  mouseactions.cpp qucs_actions.cpp	schematic_file.cpp
  wirelabel.cpp node.cpp qucs_init.cpp
  syntax.cpp misc.cpp messagedock.cpp
  settings.cpp
  imagewriter.cpp printerwriter.cpp projectView.cpp
  symbolwidget.cpp wire_planner.cpp
)

SET(QUCS_HDRS
element.h
conductor.h
healer.h
main.h
messagedock.h
misc.h
mnemo.h
module.h
mouseactions.h
node.h
octave_window.h
qucs.h
qucsdoc.h
schematic.h
settings.h
syntax.h
symbolwidget.h
textdoc.h
wire.h
wirelabel.h
wire_planner.h
)

#
# files that have Q_OBJECT need to be MOC'ed
#
SET(QUCS_MOC_HDRS
  octave_window.h
  qucs.h
  schematic.h
  textdoc.h
  messagedock.h
  projectView.h
  symbolwidget.h
)

# headers that need to be moc'ed
# generate rules for building source files from bitmap resources
SET(RESOURCES qucs.qrc)
Qt6_WRAP_CPP( QUCS_MOC_SRCS ${QUCS_MOC_HDRS} )
Qt6_ADD_RESOURCES(RESOURCES_SRCS ${RESOURCES})

if(UNIX AND NOT APPLE)

    SET(ICON16 bitmaps/hicolor/16x16/apps/${QUCS_NAME}.png )
    SET(ICON22 bitmaps/hicolor/22x22/apps/${QUCS_NAME}.png )
    SET(ICON32 bitmaps/hicolor/32x32/apps/${QUCS_NAME}.png )
    SET(ICON48 bitmaps/hicolor/48x48/apps/${QUCS_NAME}.png )
    SET(ICON64 bitmaps/hicolor/64x64/apps/${QUCS_NAME}.png )
    SET(ICON128 bitmaps/hicolor/128x128/apps/${QUCS_NAME}.png )
    SET(ICON256 bitmaps/hicolor/256x256/apps/${QUCS_NAME}.png )
    SET(ICON512 bitmaps/hicolor/512x512/apps/${QUCS_NAME}.png )
    SET(ICONsc bitmaps/hicolor/scalable/apps/${QUCS_NAME}.svg )

    INSTALL( FILES ${ICON16} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/16x16/apps)
    INSTALL( FILES ${ICON22} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/22x22/apps)
    INSTALL( FILES ${ICON32} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/32x32/apps)
    INSTALL( FILES ${ICON48} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/48x48/apps)
    INSTALL( FILES ${ICON64} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/64x64/apps)
    INSTALL( FILES ${ICON128} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/128x128/apps)
    INSTALL( FILES ${ICON256} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/256x256/apps)
    INSTALL( FILES ${ICON512} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/512x512/apps)
    INSTALL( FILES ${ICONsc} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps)

    SET(DESKTOP ${QUCS_NAME}.desktop )
    INSTALL( FILES ${DESKTOP} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
endif()




#
# configure Apple bundle information
#
IF(APPLE)
    # set information on Info.plist file
    SET(MACOSX_BUNDLE_INFO_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
    SET(MACOSX_BUNDLE_BUNDLE_VERSION "${PROJECT_NAME} ${PROJECT_VERSION}")
    SET(MACOSX_BUNDLE_LONG_VERSION_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
    SET(MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}")
    SET(MACOSX_BUNDLE_COPYRIGHT "${PROJECT_COPYRIGHT_YEAR} ${PROJECT_VENDOR}")
    SET(MACOSX_BUNDLE_GUI_IDENTIFIER "${PROJECT_DOMAIN_SECOND}.${PROJECT_DOMAIN_FIRST}")
    SET(MACOSX_BUNDLE_BUNDLE_NAME "${PROJECT_NAME}")
    SET(MACOSX_BUNDLE_ICON_FILE qucs.icns)

    # set where in the bundle to put the icns file
    SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_SOURCE_DIR}/bitmaps/qucs.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
    # include the icns file in the target
    SET(QUCS_SRCS ${QUCS_SRCS} ${CMAKE_CURRENT_SOURCE_DIR}/bitmaps/qucs.icns)

    # This tells cmake where to place the translations inside the bundle
    #SET_SOURCE_FILES_PROPERTIES( ${LANG_SRCS} PROPERTIES MACOSX_PACKAGE_LOCATION Resources/lang )
    # include the translation files in the target
    #SET(RESOURCES_SRCS ${RESOURCES_SRCS} ${LANG_SRCS})
ENDIF(APPLE)

set(app_icon_resource_windows "${CMAKE_CURRENT_SOURCE_DIR}/qucs_icon.rc")
#
#  CMake's way of creating an executable
#
ADD_EXECUTABLE( ${QUCS_NAME} MACOSX_BUNDLE WIN32
  ${QUCS_HDRS}
  ${QUCS_SRCS}
  ${QUCS_MOC_SRCS}
  ${RESOURCES_SRCS}
  ${app_icon_resource_windows}
 )

#
# Tell CMake which libraries we need to link our executable against.
#
TARGET_LINK_LIBRARIES( ${QUCS_NAME}
    components diagrams dialogs geometry paintings extsimkernels spicecomponents magnetics qt3_compat
    Qt6::Core  Qt6::Gui  Qt6::Widgets Qt6::Svg  Qt6::SvgWidgets Qt6::Xml  Qt6::PrintSupport )
SET_TARGET_PROPERTIES(${QUCS_NAME} PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
#
# Prepare the installation
#
SET(plugin_dest_dir bin)
SET(qtconf_dest_dir bin)
SET(APPS "${CMAKE_INSTALL_PREFIX}/bin/${PROJECT_NAME}")
IF(APPLE)
  SET(plugin_dest_dir ${PROJECT_NAME}.app/Contents/MacOS)
  SET(qtconf_dest_dir ${PROJECT_NAME}.app/Contents/Resources)
  SET(APPS "${CMAKE_INSTALL_PREFIX}/bin/${PROJECT_NAME}.app")
ENDIF(APPLE)

IF(WIN32)
  SET(APPS "${CMAKE_INSTALL_PREFIX}/bin/${PROJECT_NAME}.exe")
ENDIF(WIN32)

#
# Install the Qucs application, on Apple, the bundle is
# installed as on other platforms it'll go into the bin directory.
#
INSTALL(TARGETS ${QUCS_NAME}
    BUNDLE DESTINATION bin COMPONENT Runtime
    RUNTIME DESTINATION bin COMPONENT Runtime
    )

#
# Install needed Qt plugins by copying directories from the qt installation
# One can cull what gets copied by using 'REGEX "..." EXCLUDE'
#
IF(APPLE AND QT_PLUGINS_DIR)
  INSTALL(DIRECTORY "${QT_PLUGINS_DIR}/imageformats" DESTINATION bin/${plugin_dest_dir}/plugins COMPONENT Runtime)
ENDIF()
#
# install a qt.conf file
# this inserts some cmake code into the install script to write the file
#
IF(APPLE)
INSTALL(CODE "
    file(WRITE \"\${CMAKE_INSTALL_PREFIX}/bin/${qtconf_dest_dir}/qt.conf\" \"\")
    " COMPONENT Runtime)
ENDIF()

#--------------------------------------------------------------------------------
# Use BundleUtilities to get all other dependencies for the application to work.
# It takes a bundle or executable along with possible plugins and inspects it
# for dependencies.  If they are not system dependencies, they are copied.

# directories to look for dependencies
IF(APPLE)
  SET(DIRS ${QT_LIBRARY_DIRS})
ENDIF()

# Now the work of copying dependencies into the bundle/package
# The quotes are escaped and variables to use at install time have their $ escaped
# An alternative is the do a configure_file() on a script and use install(SCRIPT  ...).
# Note that the image plugins depend on QtSvg and QtXml, and it got those copied
# over.
IF(APPLE)
INSTALL(CODE "
    file(GLOB_RECURSE QTPLUGINS
      \"\${CMAKE_INSTALL_PREFIX}/bin/${plugin_dest_dir}/plugins/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
    include(BundleUtilities)
    fixup_bundle(\"${APPS}\" \"\${QTPLUGINS}\" \"${DIRS}\")
    " COMPONENT Runtime)
ENDIF()

INSTALL( FILES ${SCRIPTS} DESTINATION bin/ )

INSTALL( FILES ${QUCS_NAME}.1 DESTINATION share/man/man1 )

# Install wrapper scripts
IF(WIN32)
  SET(SCRIPTS qucs_run_hdl.bat qucs_run_verilog.bat qucs_mkdigilib.bat)
ELSE()
  SET(SCRIPTS qucs_run_hdl qucs_run_verilog qucs_mkdigilib)
ENDIF()
INSTALL( FILES ${SCRIPTS} PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
    GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ DESTINATION bin/ )


# To Create a package, one can run "cpack -G DragNDrop CPackConfig.cmake" on Mac OS X
# where CPackConfig.cmake is created by including CPack
# And then there's ways to customize this as well
#set(CPACK_BINARY_DRAGNDROP ON)
#include(CPack)

=== qucsator_rf/CMakeLists.txt ===
# ~~~

#
# You can change the install location by running cmake like this: mkdir build;
# cd build cmake .. -DCMAKE_INSTALL_PREFIX=/new/install/prefix

# Notes:
#
# * By default, the prefix is "/usr/local"
# * Use -DADMSXML_DIR=[path] to give the path containing admsXml submodules (ADMS)
# * Bison can be pointed to with -DBISON_DIR=[path]

# Running with QtCreator Open this CMakeLists.txt with 'Open File or Project..."
# Provide CMake arguments: * Set admsXml path, (after building with Autotools) *
# Enable debug symbols for the debugger.
#
# Add the following arguments to the 'Run CMake': -DAMSXML_DIR=~/git/qucs/qucs-
# core/adms/admsXml/ -DCMAKE_BUILD_TYPE:STRING=Debug
#
# With Homebrew/MacPorts on Mac OS X: It might be necessary to change the PATH
# variable on the Build Environment. Prepend '/usr/local/bin' before '/usr/bin/'
# otherwise it will find the older executables provided by Apple.

# Build
# * qucsator
# * libqucs
# * qucsconv
#

# ~~~
cmake_minimum_required(VERSION 3.10)
project(qucs-core CXX)

include(CheckSymbolExists)
include(CheckCXXSymbolExists)


# otherwise qucsator cannot generate qucsdefs.h
add_definitions(-DDEBUG)

# defines nr_double_t
add_definitions(-DHAVE_CONFIG_H)

# ~~~
# TODO
# OPTION(ENABLE_QUCSLIB "enable qucslib build, default: OFF")
# OPTION(ENABLE_DOUBLE " type of double representation, default=double")

# TODO configure debug/release flags

# TODO check flags used on Autotools are needed:
#
# -pipe : Use pipes rather than temporary files for communication between the
# various stages of compilation.
#
# https://blog.mozilla.org/nnethercote/2011/01/18/the-dangers-of-fno-exceptions/
# -fno-exceptions option is used, which means that exception-handling is
# disabled.
#
# -fno-rtti :  Disable generation of information about every class with virtual
# functions.
#
# -fno-check-new : specific to GCC
#
# -Wmissing-prototypes : Warn if a global function is defined without a previous
# prototype declaration.
#
# ~~~

# use top VERSION file
file(STRINGS ${qucs-core_SOURCE_DIR}/VERSION QUCS_VERSION)
message(STATUS "Configuring ${PROJECT_NAME}: VERSION ${QUCS_VERSION}")

set(PROJECT_VERSION "${QUCS_VERSION}")

set(PROJECT_VENDOR "Qucs team. This program is licensed under the GNU GPL")

set(QUCS_URL "https://sf.net/p/qucs")
set(QUCS_BUGREPORT "qucs-bugs@lists.sourceforge.net")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doc/qucsconv.1.cmake.in
               ${CMAKE_CURRENT_SOURCE_DIR}/doc/qucsconv.1)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doc/qucsator.1.cmake.in
               ${CMAKE_CURRENT_SOURCE_DIR}/doc/qucsator.1)

# use last git commit hash along the version
set(GIT unknown)
if(EXISTS ${CMAKE_SOURCE_DIR}/../.git)
  find_package(Git)
  # Get the latest abbreviated commit hash of the working branch
  execute_process(
    COMMAND ${GIT_EXECUTABLE} log --pretty=format:%h -n 1u
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_COMMIT_HASH)
  set(GIT ${GIT_COMMIT_HASH})
  message(STATUS "Found Git repository, last commit hash: ${GIT}")
endif()

# TODO rename the above variables? Project/Package?

# Define to the address where bug reports for this package should be sent.
set(PACKAGE_BUGREPORT "qucs-bugs@lists.sourceforge.net")

# Define to the full name of this package.
set(PACKAGE_NAME "qucs-core")

# Define to the full name and version of this package.
set(PACKAGE_STRING "${PACKAGE_NAME} ${PROJECT_VERSION}")

# Define to the one symbol short name of this package.
set(PACKAGE_TARNAME ${PACKAGE_NAME})

# Define to the home page for this package.
set(PACKAGE_URL "http://sourceforge.net/projects/qucs/")

# Define to the version of this package.
set(PACKAGE_VERSION ${PROJECT_VERSION})

#
# Avoid source tree pollution
#
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(
    FATAL_ERROR
      "\nIn-source builds are not permitted.
                       Make a separate folder for building:
                       $ mkdir build; cd build; cmake ..
                       Before that, remove the files already created:
                       $ rm -rf CMakeCache.txt CMakeFiles")
endif()

#
# Set locations of CMake modules, used on tests, find,...
#
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")

#
# Need Flex
#
find_package(FLEX 2.5.9 REQUIRED)
if(FLEX_FOUND)
endif()

# ~~~
# Need Bison
#
# This is a HACK to get around a PATH issue with Qt Creator on OSX.
# It seams impossible to pass a custom PATH to Qt Creator on OSX, ie, cannot prepend `/usr/local/bin/` for instance.
# The FIND_PACKAGE fails. For now we provide a fallback with a custom FIND_PROGRAM.
# The variable BISON_DIR is also available.
# ~~~
if(WIN32)
  find_package(BISON 2.4 REQUIRED)
else() # Linux, OSX
  if(APPLE)
    find_program(BISON_EXECUTABLE bison
        PATHS 
            "/opt/homebrew/opt/bison/bin/"
            "/usr/local/opt/bison/bin/"
        NO_DEFAULT_PATH
    )
    
    if(NOT BISON_EXECUTABLE)
        message(FATAL_ERROR "Bison 3.0.0 executable not found")
    else()
        message(STATUS "Bison found: ${BISON_EXECUTABLE}")
        set(BISON_EXECUTABLE ${BISON_EXECUTABLE} CACHE FILEPATH "Path to Bison executable")
    endif()
    find_package(BISON 3.0.0 REQUIRED)
  else(APPLE)
     # use -DBISON_DIR=/path/ to provide the path to bison
    find_program(
      BISON_EXECUTABLE bison
      PATHS /usr/local/bin/ /opt/local/bin/ /usr/bin ${BISON_DIR}
      DOC "bison path"
      NO_DEFAULT_PATH)
    if(BISON_EXECUTABLE)
      message(STATUS "Found bison: " ${BISON_EXECUTABLE})
    else()
      message(
        FATAL_ERROR "Unable to find bison. Try to provide -DBISON_DIR=[path]")
  endif()
  endif(APPLE)

endif()

#
# Check for gperf
#
find_program(GPERF_TOOL NAMES gperf)
if(NOT GPERF_TOOL)
  message(FATAL_ERROR "gperf required in PATH")
else()
  message(STATUS "Found gperf: " ${GPERF_TOOL})
endif()

#
# Check if admsXml is available
#
# * Use -DADMSXML_DIR=[path] to give the path containing admsXml
# * Try a few other locations
#
if(WITH_ADMS)
find_program(
  ADMSXML admsXml
  HINTS ${ADMSXML_DIR}
  PATHS /usr/local/bin/ /opt/local/bin/ /usr/bin
  DOC "admsXml application")
if(NOT ADMSXML)
  message(FATAL_ERROR "admsXml required in PATH")
else()
  message(STATUS "Found admsXml: " ${ADMSXML})
endif()
ENDIF()

#
# Set up RPATH for the project
#
#option(ENABLE_RPATH "Enable rpath support on Linux and Mac" OFF)
#if(NOT CMAKE_INSTALL_RPATH)
#  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
#endif()
#if(APPLE AND NOT CMAKE_INSTALL_NAME_DIR)
#  set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
#endif()
#if(UNIX AND ENABLE_RPATH)
#  set(CMAKE_SKIP_BUILD_RPATH FALSE)
#  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
#  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
#  set(CMAKE_MACOSX_RPATH TRUE)
#endif()

# CMake adds --enable-all-exports on Cygwin (since Cygwin is supposed to be
# UNIX-like), but we need to add it explicitly for a native windows build with
# the MinGW tools.
if(WIN32 AND NOT MSVC)
  set(CMAKE_SHARED_LIBRARY_CREATE_C_FLAGS
      "-shared -Wl,--export-all-symbols -Wl,--enable-auto-import")
  set(CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS
      "-shared -Wl,--export-all-symbols -Wl,--enable-auto-import")
  set(CMAKE_EXE_LINKER_FLAGS "-Wl,--enable-auto-import")
endif()


set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS ON)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
        add_compile_definitions(_CRT_SECURE_NO_WARNINGS _SCL_SECURE_NO_WARNINGS)
        add_compile_options(/permissive- /Zc:__cplusplus /Zc:preprocessor /MP /Od /vmg)
        add_compile_options(/wd4244 /wd4267 /wd4312)
    else()
        add_compile_options(-Wall -Wextra -O0 -g)
        if (CMAKE_CXX_COMPILER_ID MATCHES "^AppleClang$|^Clang$")
            add_compile_options(-Wno-ignored-attributes)
        endif()
    endif()
elseif(CMAKE_BUILD_TYPE STREQUAL "Release")
    if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
        add_compile_definitions(_CRT_SECURE_NO_WARNINGS _SCL_SECURE_NO_WARNINGS)
        string(REGEX REPLACE "/W3" "/w" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
        add_compile_options(/permissive- /Zc:__cplusplus /Zc:preprocessor /MP /vmg)
    else()
        add_compile_options(-w)
    endif()
endif()


#
# Set position independent code PIC
#
if(UNIX AND NOT APPLE)
  if(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
  endif()
endif()

#
# Go look for stuff to build/install...
#
add_subdirectory(src)
add_subdirectory(doc)

#
# Custom uninstall target
#
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/uninstall.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/uninstall.cmake" IMMEDIATE @ONLY)

add_custom_target(
  uninstall-core COMMAND ${CMAKE_COMMAND} -P
                        ${CMAKE_CURRENT_BINARY_DIR}/uninstall.cmake)

# TODO install distributables EXTRA_DIST = BUGS bootstrap depcomp RELEASE

# TODO tarball TODO bundle

set(CPACK_GENERATOR "TGZ")
# SET(CPACK_DEBIAN_PACKAGE_MAINTAINER "guitorri") #required

# build a CPack driven installer package include
# (InstallRequiredSystemLibraries)
set(CPACK_PACKAGE_VERSION_MAJOR 0)
set(CPACK_PACKAGE_VERSION_MINOR 18)
include(CPack)

=== qucs-attenuator/bitmaps/CMakeLists.txt ===

SET(XPMS
)

# toolbar images
SET(PNGS
att_pi.png
att_tee.png
att_bridge.png
)

# application images
SET(ICONS
)

INSTALL(FILES ${XPMS} DESTINATION share/qucs/bitmaps)
INSTALL(FILES ${PNGS} DESTINATION share/qucs/bitmaps)
INSTALL(FILES ${ICONS} DESTINATION share/qucs/bitmaps)

=== qucs/components/CMakeLists.txt ===
# qucs/components library

INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} )

#INCLUDES = $(X11_INCLUDES) $(QT_INCLUDES) -I$(top_srcdir)/qucs

SET(COMPONENTS_SRCS
DLS_1ton.cpp		dff_SR.cpp		logical_buf.cpp		potentiometer.cpp
DLS_nto1.cpp		diac.cpp		logical_inv.cpp		rectline.cpp
digi_sim.cpp		logical_nand.cpp	relais.cpp
digi_source.cpp		logical_nor.cpp		resistor.cpp
MESFET.cpp		diode.cpp		logical_or.cpp		rfedd.cpp
ac_sim.cpp		dmux2to4.cpp		logical_xnor.cpp	rfedd2p.cpp
am_modulator.cpp	dmux3to8.cpp		logical_xor.cpp		rlcg.cpp
ampere_ac.cpp		dmux4to16.cpp		mod_amp.cpp		rs_flipflop.cpp
ampere_dc.cpp		ecvs.cpp
			eqndefined.cpp		#module.cpp
source_ac.cpp
ampere_noise.cpp	equation.cpp		mosfet.cpp		sp_sim.cpp
amplifier.cpp		etr_sim.cpp
			fa1b.cpp		mosfet_sub.cpp		sparamfile.cpp
andor4x2.cpp		fa2b.cpp		mscorner.cpp		spicedialog.cpp
andor4x3.cpp		gatedDlatch.cpp		mscoupled.cpp
andor4x4.cpp		greytobinary4bit.cpp	mscross.cpp		spicefile.cpp
attenuator.cpp		ground.cpp		msgap.cpp
biast.cpp		gyrator.cpp		mslange.cpp		subcircuit.cpp
binarytogrey4bit.cpp	ha1b.cpp		msline.cpp		subcirport.cpp
bjt.cpp			hb_sim.cpp		msmbend.cpp		substrate.cpp
bjtsub.cpp			msopen.cpp		switch.cpp
bondwire.cpp				msrstub.cpp		symtrafo.cpp
msstep.cpp		tff_SR.cpp
mstee.cpp		thyristor.cpp
capacitor.cpp		msvia.cpp		tline.cpp
cccs.cpp		mutual.cpp		tline_4port.cpp
ccvs.cpp		mutual2.cpp		tr_sim.cpp
circulator.cpp		mux2to1.cpp		transformer.cpp
coaxialline.cpp		mux4to1.cpp		triac.cpp
comp_1bit.cpp		hpribin4bit.cpp		mux8to1.cpp		tunneldiode.cpp
comp_2bit.cpp		hybrid.cpp		nigbt.cpp		twistedpair.cpp
comp_4bit.cpp		iexp.cpp		noise_ii.cpp		vafile.cpp
component.cpp		ifile.cpp		noise_iv.cpp		vccs.cpp
componentdialog.cpp	inductor.cpp		noise_vv.cpp		vcvs.cpp
iprobe.cpp		opamp.cpp		verilogfile.cpp		vcresistor.cpp
coplanar.cpp		ipulse.cpp		opt_sim.cpp		vexp.cpp
coupler.cpp		irect.cpp		optimizedialog.cpp	vfile.cpp
cpwgap.cpp		isolator.cpp	vhdlfile.cpp
cpwopen.cpp		jfet.cpp		pad2bit.cpp		volt_ac.cpp
cpwshort.cpp		jk_flipflop.cpp		pad3bit.cpp		volt_dc.cpp
cpwstep.cpp		jkff_SR.cpp		pad4bit.cpp		volt_noise.cpp
ctline.cpp		libcomp.cpp		param_sweep.cpp		vprobe.cpp
d_flipflop.cpp		log_amp.cpp		phaseshifter.cpp	vpulse.cpp
dc_sim.cpp		logic_0.cpp		photodiode.cpp		vrect.cpp
dcblock.cpp		logic_1.cpp		phototransistor.cpp
dcfeed.cpp		logical_and.cpp		pm_modulator.cpp
vcresistor.cpp
vacomponent.cpp
mutualx.cpp
indq.cpp
capq.cpp
circline.cpp
taperedline.cpp
circularloop.cpp
spiralinductor.cpp
simulation.cpp
vdmos.cpp
property.cpp
)

SET(COMPONENTS_HDRS
ac_sim.h
am_modulator.h
ampere_ac.h
ampere_dc.h
ampere_noise.h
amplifier.h
andor4x2.h
andor4x3.h
andor4x4.h
attenuator.h
biast.h
binarytogrey4bit.h
bjt.h
bjtsub.h
bondwire.h
capacitor.h
capq.h
cccs.h
ccvs.h
circline.h
circulator.h
coaxialline.h
comp_1bit.h
comp_2bit.h
comp_4bit.h
component.h
componentdialog.h
components.h
coplanar.h
coupler.h
cpwgap.h
cpwopen.h
cpwshort.h
cpwstep.h
ctline.h
d_flipflop.h
dc_sim.h
dcblock.h
dcfeed.h
dff_SR.h
diac.h
digi_sim.h
digi_source.h
diode.h
DLS_1ton.h
DLS_nto1.h
dmux2to4.h
dmux3to8.h
dmux4to16.h
ecvs.h
eqndefined.h
equation.h
etr_sim.h
fa1b.h
fa2b.h
gatedDlatch.h
greytobinary4bit.h
ground.h
gyrator.h
ha1b.h
hb_sim.h
hpribin4bit.h
hybrid.h
iexp.h
ifile.h
indq.h
inductor.h
iprobe.h
ipulse.h
irect.h
isolator.h
jfet.h
jk_flipflop.h
jkff_SR.h
libcomp.h
log_amp.h
logic_0.h
logic_1.h
logical_and.h
logical_buf.h
logical_inv.h
logical_nand.h
logical_nor.h
logical_or.h
logical_xnor.h
logical_xor.h
MESFET.h
mod_amp.h
mosfet_sub.h
mosfet.h
mscorner.h
mscoupled.h
mscross.h
msgap.h
mslange.h
msline.h
msmbend.h
msopen.h
msrstub.h
msstep.h
mstee.h
msvia.h
mutual.h
mutual2.h
mux2to1.h
mux4to1.h
mux8to1.h
nigbt.h
noise_ii.h
noise_iv.h
noise_vv.h
opamp.h
opt_sim.h
optimizedialog.h
pad2bit.h
pad3bit.h
pad4bit.h
param_sweep.h
phaseshifter.h
photodiode.h
phototransistor.h
pm_modulator.h
potentiometer.h
property.h
rectline.h
relais.h
resistor.h
rfedd.h
rfedd2p.h
rlcg.h
rs_flipflop.h
simulation.h
source_ac.h
sp_sim.h
sparamfile.h
spicedialog.h
spicefile.h
subcircuit.h
subcirport.h
substrate.h
switch.h
symtrafo.h
taperedline.h
tff_SR.h
thyristor.h
tline_4port.h
tline.h
tr_sim.h
transformer.h
triac.h
tunneldiode.h
twistedpair.h
vacomponent.h
vafile.h
vccs.h
vcresistor.h
vcvs.h
verilogfile.h
vexp.h
vfile.h
vhdlfile.h
volt_ac.h
volt_dc.h
volt_noise.h
vprobe.h
vpulse.h
vrect.h
circularloop.h
spiralinductor.h
vdmos.h
)



SET(COMPONENTS_MOC_HDRS
componentdialog.h
spicedialog.h
optimizedialog.h
spicefile.h
)


qt6_wrap_cpp(COMPONENTS_MOC_SRCS ${COMPONENTS_MOC_HDRS})



ADD_LIBRARY(components STATIC ${COMPONENTS_HDRS} ${COMPONENTS_SRCS} ${COMPONENTS_MOC_SRCS} )

=== qucs/python/CMakeLists.txt ===
# python scripts

SET(BASICS
  parse_result.py
  parse_result_example.py
  rc_ac_sweep.dat
  rc_ac_sweep.net
)

INSTALL(FILES ${BASICS} DESTINATION share/${QUCS_NAME}/python/)

=== qucs/python/requirements.txt ===
contourpy==1.3.1
cycler==0.12.1
fonttools==4.55.3
kiwisolver==1.4.8
matplotlib==3.10.0
numpy==2.2.1
packaging==24.2
pillow==11.1.0
pyparsing==3.2.1
python-dateutil==2.9.0.post0
six==1.17.0

=== qucs/spicecomponents/CMakeLists.txt ===
# qucs/components library

INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} )

#INCLUDES = $(X11_INCLUDES) $(QT_INCLUDES) -I$(top_srcdir)/qucs

SET(COMPONENTS_SRCS
src_eqndef.cpp

#SPICE sections

sp_parameter.cpp
sp_csparameter.cpp
sp_globalpar.cpp
sp_options.cpp
sp_nutmeg.cpp
sp_ic.cpp
sp_nodeset.cpp
sp_model.cpp
sp_include.cpp
sp_lib.cpp
sp_func.cpp
sp_spiceinit.cpp
incl_script.cpp

#end of SPICE section

vsffm.cpp
isffm.cpp
vAmpMod.cpp
iAmpMod.cpp
vPWL.cpp
iPWL.cpp
eNL.cpp
gNL.cpp
vTRNOISE.cpp
iTRNOISE.cpp
vTRRANDOM.cpp
C_SPICE.cpp
L_SPICE.cpp
R_SPICE.cpp
K_SPICE.cpp
MESFET_SPICE.cpp
PMF_MESFET_SPICE.cpp
LTL_SPICE.cpp
UDRCTL_SPICE.cpp
LTRA_SPICE.cpp
DIODE_SPICE.cpp
NPN_SPICE.cpp
PNP_SPICE.cpp
BJT_SPICE.cpp
NJF_SPICE.cpp
PJF_SPICE.cpp
NMOS_SPICE.cpp
PMOS_SPICE.cpp
MOS_SPICE.cpp

# SPICE simulations list

sp_customsim.cpp
sp_fourier.cpp
sp_disto.cpp
sp_noise.cpp
sp_pz.cpp
xyce_script.cpp
sp_sens.cpp
sp_sens_ac.cpp
sp_sens_xyce.cpp
sp_sens_tr_xyce.cpp
sp_spectrum.cpp

# 
# Qucs-S new components cpp list
#


S4Q_V.cpp
S4Q_Ieqndef.cpp
S4Q_I.cpp
S4Q_S.cpp
S4Q_W.cpp
#
# XSPICE cpp list
#

#Icouple.cpp
#core.cpp
SDTF.cpp
XAPWL.cpp

#XSPICE CodeModel
xspicegeneric.cpp
#xsp_cmlib.cpp
#xsp_codemodel.cpp

#SPICE file devices
spicegeneric.cpp
spicelibcomp.cpp
)

SET(COMPONENTS_HDRS
spicecomponents.h
src_eqndef.h

#SPICE sections

sp_parameter.h
sp_csparameter.h
sp_globalpar.h
sp_options.h
sp_nutmeg.h
sp_ic.h
sp_nodeset.h
sp_model.h
sp_include.h
sp_lib.h
sp_func.h
sp_spiceinit.h
incl_script.h

#end SPICE sections

vsffm.h
isffm.h
vAmpMod.h
iAmpMod.h
vPWL.h
iPWL.h
eNL.h
gNL.h
vTRNOISE.h
iTRNOISE.h
vTRRANDOM.h
C_SPICE.h
L_SPICE.h
R_SPICE.h
K_SPICE.h
MESFET_SPICE.h
PMF_MESFET_SPICE.h
LTL_SPICE.h
UDRCTL_SPICE.h
LTRA_SPICE.h
DIODE_SPICE.h
NPN_SPICE.h
PNP_SPICE.h
BJT_SPICE.h
NJF_SPICE.h
PJF_SPICE.h
NMOS_SPICE.h
PMOS_SPICE.h
MOS_SPICE.h
sp_customsim.h
sp_fourier.h
sp_disto.h
sp_noise.h
sp_pz.h
sp_sens.h
sp_sens_ac.h
sp_sens_xyce.h
sp_sens_tr_xyce.h
xyce_script.h
sp_spectrum.h

# 
# Qucs-S new components h list
#

S4Q_V.h
S4Q_Ieqndef.h
S4Q_I.h
S4Q_S.h
S4Q_W.h
#
# XSPICE component headers
#

#Icouple.h
#core.h
SDTF.h
XAPWL.h

#XSPICE codemodel

xspicegeneric.h
#xsp_cmlib.h
#xsp_codemodel.h

#SPICE file devices
spicegeneric.h
spicelibcomp.h
)


ADD_LIBRARY(spicecomponents STATIC ${COMPONENTS_HDRS} ${COMPONENTS_SRCS} ${COMPONENTS_MOC_SRCS} )

=== qucsator_rf/doc/CMakeLists.txt ===
# EXTRA_DIST = PLATFORMS

set(MANPAGES qucsator_rf.1 qucsconv_rf.1)

install(FILES ${MANPAGES} DESTINATION share/man/man1)

=== qucsator_rf/src/interface/CMakeLists.txt ===
include_directories(
  ${qucs-core_CURRENT_SOURCE_DIR}
  ${qucs-core_SOURCE_DIR}/src/math
  ${qucs-core_SOURCE_DIR}/src/components # component.h
  ${qucs-core_BINARY_DIR}/src/components # generated verilog/[].core.h
)

set(INTERFACE_SRC qucs_interface.cpp e_trsolver.cpp)

set(HEADERS qucs_interface.h)

add_library(coreInterface OBJECT ${INTERFACE_SRC})

if (WITH_ADMS)
add_dependencies(coreInterface coreVerilog)

install(FILES ${HEADERS} DESTINATION include/qucs-core)
endif()

=== PKGBUILD ===
# Maintainer: Kreijstal <kreijstal@hotmail.com>

_realname=qucs-s
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=25.2.0
pkgrel=1
pkgdesc="A spin-off of Qucs that supports other free SPICE circuit simulators like ngspice with the same Qucs GUI"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://ra3xdh.github.io/'
msys2_repository_url='https://github.com/ra3xdh/qucs_s'
license=('spdx:gpl-2.0')
groups=("${MINGW_PACKAGE_PREFIX}-eda")
depends=(
  "${MINGW_PACKAGE_PREFIX}-qt6-base"
  "${MINGW_PACKAGE_PREFIX}-cc-libs"
  "${MINGW_PACKAGE_PREFIX}-ngspice"
  "${MINGW_PACKAGE_PREFIX}-qt6-svg"
  "${MINGW_PACKAGE_PREFIX}-qt6-charts"

)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-qt6-tools"
  "${MINGW_PACKAGE_PREFIX}-python"
  "${MINGW_PACKAGE_PREFIX}-gperf"
)
source=(
  "https://github.com/ra3xdh/qucs_s/releases/download/${pkgver}/${_realname}-${pkgver}.tar.gz"
)
sha256sums=('f88ac0e987555ac95e907bea211c4d3aeaea87085ed0cd76cfd52fa185971c42')

build() {
  cd "${srcdir}/${_realname}-${pkgver}"
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DCMAKE_BUILD_TYPE="Release" \
    -DCI_VERSION="${pkgver}" \
    ..

  cmake --build .
}


package() {
  cd "${srcdir}/${_realname}-${pkgver}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" cmake --install .
}
